#!/usr/local/bin/perl
#
# Qlog v 1.20
#	http://www.radix.net/~cknudsen/qlog/
#
# record users' ping
#
# You must have qstat available at:
#	http://www.activesw.com/people/steve/qstat.html

# Where is the ping file?  This should match the value of "ping" in qlog.cfg
$ping_file = "/export/home/cknudsen/programs/qlog/ping.dat";

# Tell me where the qstat binary is located
$qstat = "/export/home/cknudsen/programs/qlog/qstat";

# Put your server address in here... If it's not running on the default port,
# use "address:port".
@servers = (
  "dali.cninc.com",
);

# end of config parameters

# anyone playing???
foreach $s ( @servers ) {
  $result = `$qstat -ncn -P -qws $s`;
  @lines = split ( /[\r\n]+/, $result );
  @lines = grep ( /^\t#/, @lines );
  foreach ( @lines ) {
    if ( /\d+m\@(\d+)ms/ ) {
       $ping = $1;
       ( $name ) = ( split /:\d+\s*/ )[1];
       #printf "%-20s %5dms\n", $name, $ping;
       $ping{$name} = $ping;
    }
  }
}

if ( ! defined ( %ping ) ) {
  #print "No players.\n";
  exit 0;
}

# read existing ping file
if ( open ( F, "$ping_file" ) ) {
  @lines = <F>;
  chop ( @lines );
  close ( F );
  foreach ( @lines ) {
    ( $ping, $name ) = split /\t/;
    $name = $alias{$name} if ( defined ( $alias{$name} ) );
    if ( defined ( $ping{$name} ) ) {
      $ping{$name} = $ping if ( $ping < $ping{$name} );
    } else {
      $ping{$name} = $ping;
    }
  }
}

# write out ping file
if ( open ( F, ">$ping_file" ) ) {
  foreach $p ( sort keys ( %ping ) ) {
    print F "$ping{$p}\t$p\n";
  }
} else {
  print "Error opening $ping_file: $!\n";
}

exit 0;
